import { AxiosRequestConfig, AxiosResponse } from 'axios';
import { RequestConfig } from './types/RequestConfig';
export default class Request {
    private readonly service;
    private readonly config;
    private static instance;
    private interceptorAttempts;
    private static instanceConfig;
    static getInstance(): Request;
    static setConfig(config: RequestConfig): void;
    static setHeader(name: string, value: string): void;
    private constructor();
    getConfig(): RequestConfig;
    get<T = any, R = AxiosResponse<T>>(url: string, config?: AxiosRequestConfig): Promise<R>;
    post<T = any, R = AxiosResponse<T>>(url: string, data?: any, config?: AxiosRequestConfig): Promise<R>;
    patch<T = any, R = AxiosResponse<T>>(url: string, data?: any, config?: AxiosRequestConfig): Promise<R>;
    put<T = any, R = AxiosResponse<T>>(url: string, data?: any, config?: AxiosRequestConfig): Promise<R>;
    delete<T = any, R = AxiosResponse<T>>(url: string, config?: AxiosRequestConfig): Promise<R>;
}
